---
.lint-dockerfile:
  image:
    name: hadolint/hadolint:latest-alpine
  rules:
    - changes:
        - $DOCKERFILE
      when: on_success
    - when: never
  script:
    - hadolint $DOCKERFILE
  stage: lint
  
.build-kaniko-tmpl:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:v1.8.1-debug
    entrypoint: [""]
  retry: 2
  before_script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"gitlab-ci-token\",\"password\":\"$CI_JOB_TOKEN\"}}}" > /kaniko/.docker/config.json
  script:
    - time /kaniko/executor
        --context ${CONTEXT:-.}
        --dockerfile ./docker/Dockerfile
        --destination ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}.${CI_PIPELINE_ID}
        --destination ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}.latest
        --log-timestamp
        --cache
        --cache-copy-layers
        --cache-ttl $CACHE_TTL
        ${BUILD_EXTRA_ARGS}
  variables:
    CACHE_TTL: "336h"
